%define		pname suphp
%define		name %{pname}
%define		pversion 0.7.2
%define 	bversion 110
%define		rpmrelease iworx

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define		build_rhe_6x   0
%define		build_rhe_7x   0
%define     build_rhe_8x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rhe6x: 	%{expand: %%define build_rhe_6x   1}}
%{?_with_rhe7x: 	%{expand: %%define build_rhe_7x   1}}
%{?_with_rhe8x:     %{expand: %%define build_rhe_8x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

# Distro Statements

%if %{build_rhe_6x}
%define		oscode rhe6x
%define 	ostype RedHat Enterprise 6.x
BuildRequires: httpd
%define		build_unk 0
%endif

%if %{build_rhe_7x}
%define		oscode rhe7x
%define 	ostype RedHat Enterprise 7.x
BuildRequires: httpd
%define		build_unk 0
%endif

%if %{build_rhe_8x}
%define         oscode rhe8x
%define         ostype Almalinux 8.x
BuildRequires: httpd
%define         build_unk 0
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define 	ostype Unknown Distribution
%define		release %{bversion}.%{rpmrelease}
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

%define		release %{bversion}.%{rpmrelease}
%define		ccflags %{optflags}
%define		ldflags %{optflags}

############### RPM ################################

Summary:	suPHP -  suexec for PHP
Name:		%{pname}
Version:	%{pversion}
Release: 	%{release}
License:	GPL

Group:		System Environment/Daemons
Source0:	%{name}-%{version}.tar.gz
URL:		http://www.suphp.org

Distribution:	InterWorx-HAL
Vendor:         NEXCESS.NET L.L.C
Packager:	Chris Wells <clwells@nexcess.net>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

Source1:	mod_suphp.conf
Source2:	suphp.conf
Patch0:     	suphp-0.7.2-userdir.patch
Patch2:	    	suphp-0.7.2-cagefs-iworx.cl6.patch
Patch3:         suphp-0.7.2-apache24.patch

BuildRequires: apr-devel
BuildRequires: httpd-devel
BuildRequires: apr-util-devel
BuildRequires: autoconf
BuildRequires: libtool

%description
suPHP is a tool for executing PHP scripts with the permissions 
of their owners. It consists of an Apache module (mod_suphp) 
and a setuid root binary (suphp) that is called by the Apache 
module to change the uid of the process executing the PHP 
interpreter.

%prep

if [ -n %{buildroot} ] ; then rm -rf %{buildroot} ; fi

if [ -d %{_builddir}/%{name}-%{pversion} ] ; then rm -rf %{_builddir}/%{name}-%{pversion} ; fi

%setup -q -n %{name}-%{pversion}

%patch0 -p1
%patch2 -p1

%if %{build_rhe_7x}
%patch3 -p1
%endif

%if %{build_rhe_8x}
%patch3 -p1
%endif

# Try detecting newest gcc (some distributions have got more then one compiler)
# and write it on a temp file 

[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with colors ;)

if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi

# We have gcc written in a temp file
export CC="`cat %{_tmppath}/%{name}-%{pversion}-gcc` %{ccflags}"

# Delete gcc temp file
if [ -f %{_tmppath}/%{name}-%{pversion}-gcc ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-gcc ; fi

%build

if [ -n "%{buildroot}" -a "%{buildroot}" != / ] ; then rm -rf %{buildroot} ; fi

mkdir -p %{buildroot}

# Delete gcc temp file
if [ -f %{_tmppath}/%{name}-%{pversion}-gcc ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-gcc ; fi


if [ -f /usr/bin/apr-1-config ] ; then
	APR_CONFIG=/usr/bin/apr-1-config
	APR_INCLUDE="`apr-1-config --includedir`"
fi
if [ -f /usr/bin/apr-config ] ; then
	APR_CONFIG=/usr/bin/apr-config
	APR_INCLUDE="`apr-config --includedir`"
fi

export CFLAGS="$RPM_OPT_FLAGS -fomit-frame-pointer -fPIC -I$APR_INCLUDE"
export CPPFLAGS="$CFLAGS"

aclocal && libtoolize --force && automake --add-missing && autoreconf

./configure                               \
	--prefix=%{_prefix}               \
	--bindir=%{_bindir}               \
	--with-apr=$APR_CONFIG		  \
	--mandir=%{_mandir}               \
	--localstatedir=%{_localstatedir} \
	--libdir=%{_libdir}               \
	--datadir=%{_datadir}             \
	--includedir=%{_includedir}       \
	--sysconfdir=%{_sysconfdir}       \
        --with-setid-mode=paranoid        \
	--with-min-uid=100                \
	--with-min-gid=100                \
	--with-apache-user=apache         \
	--with-logfile=%{_localstatedir}/log/httpd/suphp.log

%{__make} %{?_smp_mflags}

%install

## make the "install" dir
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_libdir}/httpd/modules
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d

install -m0755 src/apache2/.libs/mod_suphp.so \
	%{buildroot}%{_libdir}/httpd/modules
install -m4755 src/suphp \
	%{buildroot}%{_sbindir}
install -m0644 %{SOURCE1} \
	%{buildroot}%{_sysconfdir}/httpd/conf.d/suphp.conf
install -m0644 %{SOURCE2} \
	%{buildroot}%{_sysconfdir}

%clean
if [ -n "%{buildroot}" -a "%{buildroot}" != / ] ; then rm -rf %{buildroot} ; fi
if [ -d %{_builddir}/%{name}-%{pversion} ] ; then rm -rf %{_builddir}/%{name}-%{pversion} ; fi

%pre

%postun

if [ -d %{_localstatedir}/%{name} ] ; then rm -rf %{_localstatedir}/%{name} ; fi

%post
# make a php-cgi symlink if it doesn't already exist - suphp wants to use cgi mode
if [ ! -f /usr/bin/php-cgi ] ; then
	ln -s /usr/bin/php /usr/bin/php-cgi
	/sbin/service httpd stop > /dev/null 2>&1
	killall -9 httpd > /dev/null 2>&1
	/sbin/service httpd restart > /dev/null 2>&1
fi

if [ -x /sbin/service ]; then
        /sbin/service httpd status > /dev/null 2>&1
        if [ "$?" -eq "0" ]; then
                /sbin/service httpd condrestart > /dev/null 2>&1 || :
        fi
fi

%files
%defattr(-,root,root)

%attr(0755,root,root) %{_libdir}/httpd/modules/mod_suphp.so
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/httpd/conf.d/suphp.conf
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/suphp.conf
%attr(4755,root,root) %{_sbindir}/suphp

%changelog
* Wed Aug 05 2015 Matt Parmelee <mparmelee@interworx.com>
- Prevented handling of files with 'php' in middle of name.
* Tue Feb 24 2015 Matt Parmelee <mparmelee@interworx.com>
- Updated for RHEL7x.
* Tue Aug 19 2014 Paul Oehler <poehler@interworx.com>
- Upgraded to 0.7.2
* Wed Jan 30 2013 Matt Parmelee <mparmelee@interworx.com>
- suPhp is now disabled by default.
* Wed Jan 09 2013 Matt Parmelee <mparmelee@interworx.com>
- Added conderestart to %post
* Wed May 28 2012 Paul Oehler <poehler@interworx.com> - Added suphp-0.7.1-cagefs.patch patch from cloud linux
* Thu May 06 2010 Paul Oehler <poehler@interworx.com>
- Updated for RHEL 6.x
* Fri Nov 06 2009 Paul Oehler <poehler@interworx.com>
- changed suphp.conf umask from 0077 0022 so that files created via php are readable by apache
* Sun Nov 01 2009 Paul Oehler <poehler@interworx.com>
- got rid of the _php _suphp prefix, no longer needed, bump to 104
* Thu Jun 23 2005 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS
